<?php
class ControllerExtensionModuleTestimonial extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/testimonial');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('module_testimonial', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true));
		}

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/module/testimonial', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['action'] = $this->url->link('extension/module/testimonial', 'user_token=' . $this->session->data['user_token'], true);

		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true);
		
		$data_array = array(
			'module_testimonial_name' => '',
			'module_testimonial_admin_approved' => 0,
			'module_testimonial_default_rating' => 5,
			'module_testimonial_send_to_admin' => 0,
			'module_testimonial_all_page_limit' => 10,
			'module_testimonial_limit' => 6,
			'module_testimonial_random' => 0,
			'module_testimonial_character_limit' => 185
		);

		foreach($data_array as $key => $value){
			if (isset($this->request->post[$key])) {
				$data[$key] = $this->request->post[$key];
			} else {
				$data[$key] = $this->config->get($key);
			}
		}
		

		if (isset($this->request->post['module_testimonial_status'])) {
			$data['module_testimonial_status'] = $this->request->post['module_testimonial_status'];
		} else {
			$data['module_testimonial_status'] = $this->config->get('module_testimonial_status');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/testimonial', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/module/testimonial')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}
	
	public function install(){
			$this->load->model('extension/module/testimonial');
			$this->model_extension_module_testimonial->install();
			$data['redirect'] = 'extension/extension/module';
            $this->load->controller('marketplace/modification/refresh', $data);
		}	
	public function uninstall(){
			$this->load->model('extension/module/testimonial');
			$this->model_extension_module_testimonial->uninstall();
            $data['redirect'] = 'extension/extension/module';
            $this->load->controller('marketplace/modification/refresh', $data);
	}
}