<?php
Class ModelExtensionModuleTestimonial extends Model{

	public function addTestimonial($data) {
		$this->db->query("INSERT INTO " . DB_PREFIX . "testimonial SET name='".$this->db->escape($data['name'])."', city = '".$this->db->escape($data['city'])."', status = '" . (int)$data['status'] . "',rating = '".(int)$data['rating'] . "',date_added = '" . $this->db->escape($data['date_added']) . "',email='" . $this->db->escape($data['email']) . "'");

		$testimonial_id = $this->db->getLastId();

		foreach ($data['testimonial_description'] as $language_id => $value) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "testimonial_description SET testimonial_id = '" . (int)$testimonial_id . "', language_id = '" . (int)$language_id . "',  description = '" . $this->db->escape($value['description']) . "', reply = '" . $this->db->escape($value['reply']) . "'");
		}

	}

	public function editTestimonial($testimonial_id, $data) {
		$this->db->query("UPDATE " . DB_PREFIX . "testimonial SET name='".$this->db->escape($data['name'])."', city = '".$this->db->escape($data['city'])."', status = '" . (int)$data['status'] . "',date_added = '".$this->db->escape($data['date_added']). "',rating = '".(int)$data['rating']."',email='". $this->db->escape($data['email']) ."' WHERE testimonial_id = '" . (int)$testimonial_id . "'");

		$this->db->query("DELETE FROM " . DB_PREFIX . "testimonial_description WHERE testimonial_id = '" . (int)$testimonial_id . "'");

		foreach ($data['testimonial_description'] as $language_id => $value) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "testimonial_description SET testimonial_id = '" . (int)$testimonial_id . "', language_id = '" . (int)$language_id . "',  description = '" . $this->db->escape($value['description']) . "', reply = '" . $this->db->escape($value['reply']) . "'");
		}

	}

	public function deleteTestimonial($testimonial_id) {
		$this->db->query("DELETE FROM " . DB_PREFIX . "testimonial WHERE testimonial_id = '" . (int)$testimonial_id . "'");
		$this->db->query("DELETE FROM " . DB_PREFIX . "testimonial_description WHERE testimonial_id = '" . (int)$testimonial_id . "'");
	}

	public function getTestimonial($testimonial_id) {
		$query = $this->db->query("SELECT DISTINCT * FROM " . DB_PREFIX . "testimonial t LEFT JOIN " . DB_PREFIX . "testimonial_description td ON (t.testimonial_id = td.testimonial_id) WHERE t.testimonial_id = '" . (int)$testimonial_id . "'");

		return $query->row;
	}

	public function getTestimonials($data = array()) {

		$sql = "SELECT * FROM " . DB_PREFIX . "testimonial t LEFT JOIN " . DB_PREFIX . "testimonial_description td ON (t.testimonial_id = td.testimonial_id) WHERE td.language_id='" . (int)$this->config->get('config_language_id') . "'";


		if(isset($data['filter_name']))	{
			$sql .= " AND LCASE(t.name) LIKE '%" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "%' ";
		}

		if(isset($data['filter_rating']))	{
			$sql .= " AND t.rating LIKE '%" . $data['filter_rating'] . "%' ";
		}

		if(isset($data['filter_date_added']))	{
			$sql .= " AND t.date_added LIKE '%" . $data['filter_date_added'] . "%' ";
		}

		if (isset($data['filter_status']) && !is_null($data['filter_status'])) {
			$sql .= " AND t.status = '" . (int)$data['filter_status'] . "'";
		}

		$sort_data = array(
			't.name',
			't.author',
			't.rating',
			't.status',
			't.date_added'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY td.description";
		}


		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = $this->db->query($sql);


		return $query->rows;

	}

	public function getTestimonialDescriptions($testimonial_id) {
		$testimonial_description_data = array();

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "testimonial_description WHERE testimonial_id = '" . (int)$testimonial_id . "'");

		foreach ($query->rows as $result) {

			$testimonial_description_data[$result['language_id']] = array(
				'description' => isset($result['description']) ? $result['description'] : '',
				'reply' => isset($result['reply']) ? $result['reply'] : ''
			);
		}

		return $testimonial_description_data;
	}

	public function isTableExists() {

		$query = $this->db->query("SHOW TABLES LIKE '" . DB_PREFIX . "testimonial'");
		$query2 = $this->db->query("SHOW TABLES LIKE '" . DB_PREFIX . "testimonial_description'");
		if (!$query->num_rows || !$query2->num_rows)
	      	$this->createDatabaseTables();
		else
	      	return TRUE;


	}


	public function getTotalTestimonials($data) {
	  	if ($this->isTableExists() == false)
	   		return -1;

			$sql = "SELECT count(*) as total FROM " . DB_PREFIX . "testimonial t LEFT JOIN " . DB_PREFIX . "testimonial_description td ON (t.testimonial_id = td.testimonial_id) WHERE td.language_id='" . (int)$this->config->get('config_language_id') . "'";


			  if(isset($data['filter_name'])) {
			   $sql .= " AND LCASE(t.name) LIKE '%" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "%' ";
			  }

			  if(isset($data['filter_rating'])) {
			   $sql .= " AND t.rating LIKE '%" . $data['filter_rating'] . "%' ";
			  }

			  if(isset($data['filter_date_added'])) {
			   $sql .= " AND t.date_added LIKE '%" . $data['filter_date_added'] . "%' ";
			  }

			  if (isset($data['filter_status']) && !is_null($data['filter_status'])) {
			   $sql .= " AND t.status = '" . (int)$data['filter_status'] . "'";
			  }


			  $query = $this->db->query($sql);

			  return $query->row['total'];
	}
	
	public function getNewTestimonials() {
		$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "testimonial WHERE status = '0'");

		return $query->row['total'];
	}
	
	public function getProcessingTestimonials() {
		$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "testimonial WHERE status = '1'");

		return $query->row['total'];
	}
	
	public function getApprovalTestimonials() {
		$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "testimonial WHERE status = '0'");

		return $query->row['total'];
	}

	public function setApproval($testimonial_id){
		$this->db->query("UPDATE " . DB_PREFIX . "testimonial SET status='1' WHERE testimonial_id = '" . (int)$testimonial_id . "'");
	}

	public function setUnapproval($testimonial_id){
		$this->db->query("UPDATE " . DB_PREFIX . "testimonial SET status='0' WHERE testimonial_id = '" . (int)$testimonial_id . "'");
	}

	public function getCurrentDateTime() {
      	$query = $this->db->query("SELECT NOW() AS cdatetime ");

		return $query->row['cdatetime'];
	}



		public function install() {			
		$this->db->query("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "testimonial` (
		  `testimonial_id` int(11) NOT NULL AUTO_INCREMENT,
		  `name` varchar(64) COLLATE utf8_bin NOT NULL,
		  `city` varchar(64) COLLATE utf8_bin DEFAULT NULL,
		  `email` varchar(96) COLLATE utf8_bin DEFAULT NULL,
		  `status` int(1) NOT NULL DEFAULT '0',
		  `rating` int(1) NOT NULL DEFAULT '0',
		  `date_added` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
		   PRIMARY KEY (`testimonial_id`)
		)  ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;");
		
		$this->db->query("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "testimonial_description` (
		  `testimonial_id` int(11) NOT NULL, 
		  `language_id` int(11) NOT NULL,
		  `title` varchar(64) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
		  `description` text COLLATE utf8_unicode_ci NOT NULL,
		  `reply` text COLLATE utf8_unicode_ci NOT NULL,
		   PRIMARY KEY (`testimonial_id`,`language_id`) 
		)  ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;");

		
		$data = array(  
				'extension_install_id' => '',
				'code' => 'Customer Testimonial',
				'name' => 'Customer Testimonial',
				'author' => 'Tom',
				'version' => '1.0',
				'link' => 'Customer Testimonial',
				'xml' => '
				<modification>
				  <name>Customer Testimonial</name>
				  <code>Customer Testimonial</code>
				  <version>1.0</version>
				  <author>Tom</author>
				  <link>Customer Testimonial</link>
				  
				  <file path="admin/controller/common/column_left.php">
				  <operation>
				   <search>
					<![CDATA[if ($this->user->hasPermission(\'access\', \'extension/module/product\')) {]]>
				   </search>
				   <add position="before">
					<![CDATA[
							if ($this->user->hasPermission(\'access\', \'extension/module/testimonial\')) {
								$catalog[] = array(
									\'name\'     => \'Отзывы о магазине\',
									\'href\'     => $this->url->link(\'extension/module/testimonial\', \'user_token=\' . $this->session->data[\'user_token\'], true),
									\'children\' => array()
								);
							}
							]]>
				   </add>
				  </operation>
				 </file>
				  <file path="admin/controller/common/header.php">
						<operation>
							<search trim="true">
								<![CDATA[$data[\'stores\'] = array();]]></search>
								<add position="after"><![CDATA[
									$this->load->model(\'extension/module/testimonial\');
									$data[\'total_testimonial\'] = $this->model_extension_module_testimonial->getTotalTestimonials($data);
									$data[\'new_testimonial\'] = $this->model_extension_module_testimonial->getNewTestimonials();
									$data[\'processing_testimonial\'] = $this->model_extension_module_testimonial->getProcessingTestimonials();

									$data[\'text_new_testimonial\'] = $this->language->get(\'text_new_testimonial\');
									$data[\'text_processing_testimonial\'] = $this->language->get(\'text_processing_testimonial\');
									$data[\'text_total_testimonial\'] = $this->language->get(\'text_total_testimonial\');
									$data[\'text_testimonial_settings\'] = $this->language->get(\'text_testimonial_settings\');

									$data[\'new_testimonial_url\'] = $this->url->link(\'extension/testimonial_list\', \'user_token=\' . $this->session->data[\'user_token\'].\'&filter_status=0\', true);
									$data[\'processing_testimonial_url\'] = $this->url->link(\'extension/testimonial_list\', \'user_token=\' . $this->session->data[\'user_token\'].\'&filter_status=1\', true);
									$data[\'total_testimonial_url\'] = $this->url->link(\'extension/testimonial_list\', \'user_token=\' . $this->session->data[\'user_token\'], true);
									$data[\'testimonial_settings\'] = $this->url->link(\'extension/module/testimonial\', \'user_token=\' . $this->session->data[\'user_token\'], true);
								]]></add>
						</operation>
						<operation>
							<search trim="true">
								<![CDATA[
									$this->load->language(\'common/header\');
								]]></search>
								<add position="after"><![CDATA[
									$this->load->language(\'extension/module/testimonial\');
									$data[\'text_notif_testimonials\'] = $this->language->get(\'text_notif_testimonials\');
									$data[\'text_no_testimonials\'] = $this->language->get(\'text_no_testimonials\');
								]]></add>
						</operation>
					</file>	

					<file path="admin/language/ru-ru/common/header.php">
						<operation>
							<search trim="true">
								<![CDATA[
									// Heading
								]]></search>
								<add position="after"><![CDATA[
									$_[\'text_notif_testimonials\']          		= \'Отзывы о магазине\';
									$_[\'text_no_testimonials\']          		    = \'Нет не опубликованых отзывов\';
									$_[\'text_new_testimonial\']          		    = \'Не одобреные\';
									$_[\'text_processing_testimonial\']          	= \'Одобреные\';
									$_[\'text_total_testimonial\']          		= \'Всего\';
									$_[\'text_testimonial_settings\']            	= \'Настройки\';
								]]></add>
						</operation>
					</file>
					<file path="admin/view/template/common/header.twig">
							<operation>
							<search><![CDATA[<ul class="nav navbar-nav navbar-right">]]></search>
								<add position="after"><![CDATA[
                               <li class="dropdown"><a class="dropdown-toggle" data-toggle="dropdown"><span class="label label-danger pull-left">{{ new_testimonial }} </span> <i class="fa fa-users" aria-hidden="true"></i></a>	
								<ul class="dropdown-menu dropdown-menu-right alerts-dropdown">
									<li class="dropdown-header">{{ text_notif_testimonials }} </li>
									<li><a href="{{ processing_testimonial_url }} "><span class="label label-success pull-right">{{ processing_testimonial }} </span>{{ text_processing_testimonial }} </a></li>
									<li><a href="{{ new_testimonial_url }} "><span class="label label-warning pull-right">{{ new_testimonial }} </span>{{ text_new_testimonial }} </a></li>
									<li><a href="{{ total_testimonial_url }} "><span class="label label-primary pull-right">{{ total_testimonial }} </span>{{ text_total_testimonial }} </a></li>
									<li><a href="{{ testimonial_settings }} "><span class="label label-danger pull-right"><i class="fa fa-cogs"></i></span>{{ text_testimonial_settings }} </a></li>
								</ul>
							</li>
								]]></add>
						</operation>
					</file>

				</modification>',
            'status' => 1
        );  
		
		$this->load->model('setting/modification');

		$mod = $this->model_setting_modification->getModificationByCode('Customer Testimonial');

		if (empty($mod)) {
			$mod = $this->model_setting_modification->getModificationByCode('Customer Testimonial');
		}

		if (empty($mod)) {
			$this->model_setting_modification->addModification($data);
		} elseif ($mod['code'] != 'Customer Testimonial') {
			$this->model_setting_modification->deleteModification($mod['modification_id']);
			$this->model_setting_modification->addModification($data);
		}
		
		$query = $this->db->query("SHOW TABLES LIKE '" . DB_PREFIX . "url_alias'");

        if ($query->rows) {
            $checkQuery = $this->db->query("SELECT * FROM " . DB_PREFIX . "url_alias WHERE `query` = 'product/testimonial'");

            if (!$checkQuery->num_rows) {
                $this->db->query("INSERT INTO " . DB_PREFIX . "url_alias SET `query` = 'product/testimonial', `keyword` = 'testimonial'");
            }

            $checkQuery = $this->db->query("SELECT * FROM " . DB_PREFIX . "url_alias WHERE `query` = 'product/posttestimonial'");

            if (!$checkQuery->num_rows) {
                $this->db->query("INSERT INTO " . DB_PREFIX . "url_alias SET `query` = 'product/posttestimonial', `keyword` = 'new_testimonials'");
            }
        }
   }
	public function uninstall() {
		$this->db->query("DROP TABLE IF EXISTS `".DB_PREFIX."testimonial`");
		$this->db->query("DROP TABLE IF EXISTS `".DB_PREFIX."testimonial_description`");
		
		$this->load->model('setting/modification');

		$modification = $this->model_setting_modification->getModificationByCode('Customer Testimonial');

		if (!empty($modification)) {
			$this->model_setting_modification->deleteModification($modification['modification_id']);
		}

	}

}