<?php
class ControllerExtensionModuleTestimonialList extends Controller {

	public function index() {
    	$languages = $this->language->load('product/testimonial');

    	foreach($languages as $key => $value){
    		$data[$key] = $value;
    	}

		$this->load->model('extension/module/testimonial');

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home')
		);

		$url = '';

		$testimonial_total = $this->model_extension_module_testimonial->getTotalTestimonials();

		if ($testimonial_total > 0) {

		$this->document->setTitle($this->language->get('heading_title'));

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/module/testimonial_list')
		);

		$url = '';
			
		if (isset($this->request->get['page'])) {
				$page = $this->request->get['page'];
		} else {
				$page = 1;
		}

		$data['testimonials'] = array();

		$testimonial_total = $this->model_extension_module_testimonial->getTotalTestimonials();

		$results = $this->model_extension_module_testimonial->getTestimonials(($page - 1) * 10, 10);

			foreach ($results as $result) {
				$data['testimonials'][] = array(
					'name'		    => $result['name'],
					'rating'		=> $result['rating'],
					'description'	=> html_entity_decode($result['description'], ENT_QUOTES, 'UTF-8'),
					'reply'	        => html_entity_decode($result['reply'], ENT_QUOTES, 'UTF-8'),
					'city'		    => $result['city'],
					'date_added'	=> date("d.m.Y", strtotime($result['date_added']))
				);
			}
			
			$data['write_url'] = $this->url->link('extension/module/posttestimonial', '', $url);

			$pagination = new Pagination();

			$pagination->total = $testimonial_total;
			$pagination->page = $page;
			$pagination->limit = 10;
			$pagination->url = $this->url->link('extension/module/testimonial_list', '&page={page}');

			$data['pagination'] = $pagination->render();

			$data['results'] = sprintf($this->language->get('text_pagination'), ($testimonial_total) ? (($page - 1) * 10) + 1 : 0, ((($page - 1) * 10) > ($testimonial_total - 10)) ? $testimonial_total : ((($page - 1) * 10) + 10), $testimonial_total, ceil($testimonial_total / 10));

			$this->document->addLink($this->url->link('extension/module/testimonial_list', '', 'SSL'), 'canonical');
			if ($page == 2)  {
				$this->document->addLink($this->url->link('extension/module/testimonial_list', '', 'SSL'), 'prev');
			} else if ($page > 2)   {
				$this->document->addLink($this->url->link('extension/module/testimonial_list', 'page='. ($page - 1), 'SSL'), 'prev');
			}

			if (10 && ceil($testimonial_total / 10) > $page) {
				$this->document->addLink($this->url->link('extension/module/testimonial_list', 'page='. ($page + 1), 'SSL'), 'next');
			}
			

			$data['continue'] = $this->url->link('common/home');

			$data['column_left'] = $this->load->controller('common/column_left');
			$data['column_right'] = $this->load->controller('common/column_right');
			$data['content_top'] = $this->load->controller('common/content_top');
			$data['content_bottom'] = $this->load->controller('common/content_bottom');
			$data['footer'] = $this->load->controller('common/footer');
			$data['header'] = $this->load->controller('common/header');

         $this->response->setOutput($this->load->view('extension/module/testimonial_list', $data));

    	} else {

			$data['continue'] = $this->url->link('common/home');

			$data['column_left'] = $this->load->controller('common/column_left');
			$data['column_right'] = $this->load->controller('common/column_right');
			$data['content_top'] = $this->load->controller('common/content_top');
			$data['content_bottom'] = $this->load->controller('common/content_bottom');
			$data['footer'] = $this->load->controller('common/footer');
			$data['header'] = $this->load->controller('common/header');

         $this->response->setOutput($this->load->view('error/not_found', $data));
    	}

  	}
}